#define _CRT_SECURE_NO_DEPRECATE
#define NOFOOTER

#include "testlib.h"
#include <cmath>
#include <iostream>
#include <cassert>

using namespace std;

const int nmax = 101;
const int vmax = 31000;

struct rect {
    int x1, y1, x2, y2;
    rect() {}
    rect ( InStream & in )
    {
        x1 = in.readInt( -vmax, vmax );
        y1 = in.readInt( -vmax, vmax );
        x2 = in.readInt( x1 + 1, vmax );
        y2 = in.readInt( y1 + 1, vmax );
    }
    rect ( int _x1, int _y1, int _x2, int _y2 ) : x1(_x1), y1(_y1), x2(_x2), y2(_y2) {}
    friend bool operator * ( const rect & a, const rect & b )
    {
        return ( a.x1 < b.x2 && b.x1 < a.x2 && a.y1 < b.y2 && b.y1 < a.y2 );
    }
    friend rect Int ( const rect & a, const rect & b )
    {
        int x[4] = { a.x1, a.x2, b.x1, b.x2 };
        sort ( x, x + 4 );
        int y[4] = { a.y1, a.y2, b.y1, b.y2 };
        sort ( y, y + 4 );
        return rect ( x[1], y[1], x[2], y[2] );
    }
    inline long long S() { return (long long)( x2 - x1 )*( y2 - y1 ); }
};

int n, k, mx, my;
int x[nmax*2];
int y[nmax*2];
bool F[nmax*2][nmax*2];
rect * a;
rect * b;

extern "C" void * memset ( void *, int, size_t );

int main ( int argc, char ** argv )
{
    registerTestlibCmd ( argc, argv );

    n = inf.readInt( 1, nmax - 1 );
    a = new rect[n];
    mx = my = 0;
    for ( int i = 0; i < n; ++i )
    {
        a[i] = rect ( inf );
        x[mx++] = a[i].x1, x[mx++] = a[i].x2;
        y[my++] = a[i].y1, y[my++] = a[i].y2;
    }

    sort ( x, x + mx );
    mx = (int)( unique ( x, x + mx ) - x );
    sort ( y, y + my );
    my = (int)( unique ( y, y + my ) - y );
    x[mx] = y[my] = vmax + 1;
    memset ( F, false, sizeof ( F ) );

    for ( int t = 1; t < n; ++t )
    {
        for ( int * p = upper_bound ( x, x + mx, a[t].x1 ); *p <= a[t].x2; p++ )
            for ( int * q = upper_bound ( y, y + my, a[t].y1 ); *q <= a[t].y2; q++ )
                F[p - x][q - y] = true;
    }

    long long area = a[0].S();
    for ( int i = 1; i < mx; ++i )
        for ( int j = 1; j < my; ++j )
            if ( F[i][j] )
                area -= (long long)( x[i] - x[i - 1] )*( y[j] - y[j - 1] );

    k = ouf.readInt ( 0, ( 2*n - 1 )*( 2*n - 1 ) );
    b = new rect[k];
    for ( int i = 0; i < k; ++i )
        b[i] = rect ( ouf );

    for ( int i = 0; i < k; ++i )
    {
        if ( b[i].x1 < a[0].x1 || b[i].x2 > a[0].x2 || b[i].y1 < a[0].y1 || b[i].y2 > a[0].y2 )
            quitf ( _wa, "%d-th rectangle get out beyond the wall", i + 1 );
        for ( int j = 0; j < i; ++j )
            if ( b[j] * b[i] )
                quitf ( _wa, "%d-th and %d-th rectangles intersect each other", j + 1, i + 1 );
        for ( int j = 1; j < n; ++j )
            if ( a[j] * b[i] )
                quitf ( _wa, "%d-th rectangle and %d-th hole intersect each other", i + 1, j + 1 );

        area -= b[i].S();
    }
    if ( area > 0 ) quit ( _wa, "Wallpapers don`t cover whole wall" );
    if ( area < 0 ) quit ( _fail, "negative resulting area, something wrong" );
    quitf ( _ok, "N = %d", n );
}
